; Emacs! This is a -*- mode: Emacs-Lisp;-*-
(setq gnus-select-method '(nntp "pyramid.sjgames.com"))

(setq gnus-secondary-select-methods
      '((nnimap "smtp.evenmere.org"
		(nnimap-server-port 8993)
		(nnimap-authinfo-file "/home/bts/.authinfo")
		(nnimap-nov-is-evil t)
		(nnimap-stream ssl))
	(nntp "netnews.attbi.com")
))

(setq gnus-use-cache t) 

(setq gnus-summary-mark-below -3000)

(setq gnus-cacheable-groups ".*"
      gnus-uncacheable-groups "^nnm"
      gnus-cache-enter-articles '(ticked dormant unread))


(setq nnmail-treat-duplicates 'delete)

;(setq nnimap-split-inbox '("INBOX"))

;(setq nnimap-split-predicate "UNDELETED")

;(setq nnimap-split-rule 'nnmail-split-fancy)

;;; view mime parts
(setq gnus-mime-view-all-parts t)

;;; dont autoload html messages if there's a text part
(setq mm-discouraged-alternatives
      '("text/html"
        "text/richtext"))

;(setq mm-automatic-display '("text/html"))


(setq nnmail-split-fancy
     ;; Messages from the mailer daemon are not crossposted to any of
     ;; the ordinary groups.  Warnings are put in a separate group
     ;; from real errors.
      '(| ("Subject" "Virus Warning" "Mail/probably-spam")
	  ("from" mail (| ("subject" "warn.*" "mail.warning")
			  "Mail/misc"))
	; If it's non-work stuff, sort it off seperate right away.
	  (& (from "webmaster@sjgames\\.com" "Mail/illuminator")
	     (any "residents@evenmere\\.org" "Mail/evenmere")
	     (from "pandemo@tiac\\.net" "Mail/illuminator")
	     (any "gurpsnet-l@\\(lists\\.\\)?io\\.com" "Mail/gurpsnet")
	     (any "earthdawn@dragonpaw\\.org" "Mail/earthdawn")
	     (any "earthdawn@lists\\.earthdawn\\.org" "Mail/earthdawn")
	     ("Subject" "Yahoo. Clubs. Legend.s of Earthdawn" "Mail/earthdawn")
 	     (any "ed2ideas@egroups\\.com" "Mail/earthdawn")
	     (any "darkness-gms" "Mail/darkness-gms")
	     (any "shadowdawn" "Mail/shadowdawn")
	     (any "fun-dnd-game@astral\\.net" "Mail/astral-dnd")
	     (any "lastdays@eccentricity\\.org" "Mail/lastdays")
	     (any "hive-gms" "Mail/hive")
	     (any "oracle\\.wizards\\.com" "Mail/dnd")
	     ("Subject" "News of the Weird" "Mail/news-of-the-weird")
	     ("Return-Path" "darkness-gms" "Mail/darkness-gms")
	     (any "ars-magica@.*berkeley\\.edu" "Mail/ars-magica")
	     (| (any "shadowRN@dumpshock\\.com" "Mail/shadowrn")
		(any "shadowrn@jackpoint\\.org" "Mail/shadowrn")))
	  (& (| (to "doom@mit\\.edu" "Mail/mit-punt")
		(to "rumor" "Mail/macondo")
		(to "macondo" "Mail/macondo")
		(to "punt.*@mit\\.edu" "Mail/mit-punt")
		(to "grograman@mit\\.edu" "Mail/mit-punt")
		(to "universe@mit\\.edu" "Mail/mit-punt")
		(to "shadowdawn" "Mail/gaming")
		(to "conspiracy-theories" "Mail/gaming")
		(to "nullspace" "Mail/gaming")
		(to "patrol-players@mit\\.edu" "Mail/mit-announce")
		(to "lsc.*@mit\\.edu" "Mail/mit-lsc")
		(to ".*lists\\.debian\\.org" "Mail/debian")
		(to ".*bugs\\.debian\\.org" "Mail/debian")
		(to "assassin.*@mit\\.edu" "Mail/mit-assassin")
		(to "generic@mit\\.edu" "Mail/mit-assassin")
		(to "mit-talk@mit\\.edu" "Mail/mit-politics")
		(to "announce.*@mit\\.edu" "Mail/mit-announce")
		(to "reuse@mit\\.edu" "Mail/mit-reuse")
		(to "free-food@mit\\.edu" "Mail/mit-reuse")
		(to "athena-outage@mit\\.edu" "Mail/mit-announce")
		(to "ihtfp" "Mail/mit-hacking")
		(to "course19" "Mail/mit-hacking")
		(to "fred@mit\\.edu" "Mail/mit-ec")
		(to "ec.*@mit\\.edu" "Mail/mit-ec")
		(to "third-?west@mit\\.edu" "Mail/mit-ec")
		(to "piwest@mit\\.edu" "Mail/mit-ec")
		(to "cthulhu@mit\\.edu" "Mail/mit-cthulhu")
		(to "foundation-gms@mit\\.edu" "Mail/foundation-gms")
		(to "doa-gms@mit\\.edu" "Mail/doa")
		(to "pscomm@mit\\.edu" "Mail/mit-religious")
		(to "lem@mit\\.edu" "Mail/mit-religious")
		(to "humou?r" "Mail/humor")))
	  (& (| (from "cert-advisory@cert\\.org" "bugtraq")
		(to "bugtraq@securityfocus\\.com" "bugtraq")
		(to "nanog@merit\\.edu" "nanog")
		(to "nanog@merit\\.org" "nanog")
		(to "nanog@nanog\\.org" "nanog")
		(to "risks@csl\\.sri\\.com" "risks")
		(to "freehaven" "freehaven")
	 ; Pull bugtraq, cpcodes, siebel out seperately from sysgrp-dev
		(to "sysgrp-dev" - "bugtraq" "syseng")
		(to "emp_ma@.*akamai\\.com" "akamai-cambridge"))
         ; Check to see if it's for me
	     (| (to "bts@.*akamai\\.com" "INBOX")
		(to "bts-pager@.*akamai\\.com" "INBOX")
		(to "8777721580@.*skytel\\.com" "INBOX")
		(to "bts@grecotha" "INBOX")
		(to "bts@evenmere.org" "INBOX")
		(to "bts@alum\\.mit\\.edu" "INBOX")
		(to "brians@mit\\.edu" "INBOX")
		(to "bts@evenmere\\.org" "INBOX")
		(to "bsniffen@.*akamai\\.com" "INBOX")
		(to "brian.sniffen@.*akamai\\.com" "INBOX")
		(to "bts@mit\\.edu" "INBOX")))
	 ; Mail to foo@akamai.com is /never/ spam.
	  (to "\\b\\([-\\.\\_A-Za-z0-9]+\\)@.*akamai\\.com" "akamai-general")
	  (to "\\b\\([-\\.\\_A-Za-z0-9]+\\)@.*mit\\.edu" "mit-general")
	 ; If not, it's probably spam
	  "probably-spam"))

;;; view mime parts
(setq gnus-auto-expirable-newsgroups "(gurpsnet)|(earthdawn)|(ars-magica)|(shadowrn)|(spam)|(akamai-spam)|(mail.misc)|(akamai-install)|(debian)|(probably-spam)|(bugtraq)|(^mit-)")

(setq gnus-asynchronous 't)

(setq nnmail-expiry-wait-function
      (lambda (group) 7))

; 	(cond ((string= group "gurpsnet")
; 	       1)
; 	      ((string= group "reuse")
; 	       1)
; 	      (t
; 	       7))))
	
(setq gnus-message-archive-group
      '((if (message-news-p)
	    "misc-news"
	  (concat "mail." (format-time-string
			   "%Y-%m" (current-time))))))

(setq gnus-fetch-old-headers 'some)
(setq gnus-build-sparse-threads 'some)
(setq gnus-add-to-list 't)

;(setq gnus-outgoing-message-group ni;)

(defun ispell-query-message-send-hook ()
  "Optionally spell-check the message"
    (when (y-or-n-p "iSpell this message? ")
    (save-excursion
      (let (start end)
       (goto-char (point-min))
       (setq start (1+ (re-search-forward mail-header-separator)))
       ;; This code would sign only the body of the message.
       ;(goto-char (point-max))
       ;(setq end (or (re-search-backward message-signature-separator nil t)
       ;              (point-max)))
       (setq end (point-max))
       (when (< start end)
         (ispell-region start end))))))



(defun gpg-message-send-hook ()
  "Stuff to be done before sending"
  (when (y-or-n-p "PGP-sign this message? ")
    (save-excursion
      (let (start end)
       (goto-char (point-min))
       (setq start (1+ (re-search-forward mail-header-separator)))
       ;; This code would sign only the body of the message.
       ;(goto-char (point-max))
       ;(setq end (or (re-search-backward message-signature-separator nil t)
       ;              (point-max)))
       (setq end (point-max))
       (when (< start end)
         (mc-sign-region 0 start end))))))

(defun restore-bbdb-keys ()
  "*When composing a message, if both bbdb and flyspell are used, restore the
bbdb key bindings in all headers likely to need name expansion."
  (interactive)
;  (map-extents (lambda (e unused) (delete-extent e))
;	       nil nil nil nil nil 'restore-bbdb-keys t)
  (when (and (eq major-mode 'message-mode)
	     (eq (lookup-key message-mode-map [27 9])
		 'bbdb-complete-name)
	     (eq (key-binding [27 9]) 'flyspell-auto-correct-word))
    (save-excursion
      (let ((limit (progn (search-forward mail-header-separator)
			  (point-at-bol))))
	(make-local-hook 'kill-buffer-hook)
	(goto-char 1)
	(while (re-search-forward "^\\(\
\\(From\\|Sender\\)\\|\
\\(\\(Mail-Copies-\\)?To\\)\\|\
\\([GBF]?[Cc][Cc]\\)\\|\
\\(Reply-[Tt]o\\)\\)\
: "
				  limit t)
	  (let* ((start (point))
		 (end (or (and (re-search-forward "^[A-Z][^: \n\t]+: " limit t)
			       (goto-char (point-at-bol)))
			  limit))
		 (extent (make-overlay start end (current-buffer) 't 't)))
	    (overlay-put extent 'local-map message-mode-map)
	    (overlay-put extent 'restore-bbdb-keys t)
	    ))))
    ))

;(add-hook 'message-send-hook 'gpg-message-send-hook)
;(add-hook 'message-send-news-hook 'gpg-message-send-hook)

;(add-hook 'message-send-hook 'ispell-query-message-send-hook)
;(add-hook 'message-send--news-hook 'ispell-query-message-send-hook)

(add-hook 'message-setup-hook 'filladapt-mode)
;(add-hook 'message-setup-hook 'mml-secure-sign-pgpmime)

(add-hook 'message-setup-hook 'restore-bbdb-keys)

(add-hook 'gnus-group-mode-hook 'gnus-topic-mode)

(add-hook 'nnmail-prepare-incoming-header-hook 'nnmail-remove-leading-whitespace)
(add-hook 'nnmail-prepare-incoming-header-hook 'nnmail-remove-list-identifiers)
(add-hook 'nnmail-prepare-incoming-header-hook 'nnmail-fix-eudora-headers)

(setq nnmail-list-identifiers 
      '("\\[all\\]"
	"\\[python-hackers\\]"
	"\\[gadgets\\]"
	"\\[auth-team\\]"
	"\\[sjgames-illuminator\\]"
	"\\[traveller-news-service\\]"
	"\\[ABOV-[0-9]*\\]"
	"\\[ADMIN\\]"
	"\\[ARS\\]"
	"\\[BLUE PLANET\\]"
	"\\[BUGTRAQ\\]"
	"\\[Earthdawn\\]"
	"\\[Hans\\]"
	"\\[New Vehicle\\]"
	"\\[bw-updates\\]"
	"\\[ccare\\]"
	"\\[cert\\]"
	"\\[cpcode-request\\]"
	"\\[customer-activation\\]"
	"\\[ed2ideas\\]"
	"\\[emp_ma\\]"
	"\\[sec-dn\\]"
	"\\[security\\]"
	"\\[ghost-roll-detailed\\]"
	"\\[install\\]"
	"\\[legal\\]"
	"\\[map\\]"
	"\\[marketing_webmaster\\]"
	"\\[monitoring\\]"
	"\\[new-customer\\]"
	"\\[support\\]"
	"\\[sweng\\]"
	"\\[sysgrp-escalate\\]"
	"\\[web-inside\\]"
	"\\[Yahoo. Clubs. Legend.s of Earthdawn\\]"))


;;* Higher Scoring of followups to myself
;;*================================
;(add-hook 'message-sent-hook 'gnus-score-followup-article)
(add-hook 'message-sent-hook (lambda () (gnus-score-followup-thread 1000)))

(setq gnus-article-hide-pgp nil)
;(add-hook 'gnus-article-hide-pgp-hook
;	  (lambda ()
;	    (save-excursion
;	      (set-buffer gnus-original-article-buffer)
;	      (mc-verify))))


(setq gnus-posting-styles
      '((".*"
	 (signature-file "~/.signature")
	 (name "Brian T. Sniffen")
	 (address "bts@alum.mit.edu"))))

;Adaptive Scoring!

(setq gnus-use-adaptive-scoring '(word line thread))

(defvar gnus-default-adaptive-score-alist
  '((gnus-unread-mark)
    (gnus-ticked-mark (from 4))
    (gnus-dormant-mark (from 5))
    (gnus-del-mark (from -4) (subject -1))
    (gnus-read-mark (from 4) (subject 2))
    (gnus-expirable-mark (from -1) (subject -1))
    (gnus-killed-mark (from -1) (subject -3))
    (gnus-kill-file-mark)
    (gnus-ancient-mark)
    (gnus-low-score-mark)
    (gnus-catchup-mark))); (from -1) (subject -1))))
(setq gnus-decay-scores 't)

; Set up for offline and remote reading
;(gnus-agentize)
; OK, only remote, and it's still buggy:
;(gnuserv-start)

;;* DEMON scanning for new mail / postings

;(setq gnus-use-demon t)
;; Initialize the Gnus daemon.
;(gnus-demon-init)
;; Add daemonic scanning of new articles from all backends.
;(gnus-demon-add-rescan)
;(gnus-demon-add-nntp-close-connection)
;(gnus-demon-add-scanmail)

;;(defun gnus-demon-my-scan-mail ()
;;   (when (and (gnus-alive-p) mail-here)
;;     (save-excursion
;;       (set-buffer gnus-group-buffer)
;;        ;Get newly arrived articles.
;;       (gnus-group-get-new-news 3)
;;       )
;;     )
;;   )

;; (gnus-demon-add-handler 'gnus-demon-my-scan-mail 5 1)
